function [Result] = ApsidalmotionPlusLITE(JD00,JDi,Epo0,Weight,N,P,excen1,dodt,omega1,T0,A,p3,omega3,excen3,qmt)

OcLITE = OminusC(JDi,T0,A,p3,omega3,excen3);
O=JDi-JD00-P*Epo0 - OcLITE - 10^(-10)*qmt*Epo0.*Epo0;         %O-C difference, linear ephemeris + LITE + quadratic term

PocetPr=0;
PocetS=0;
for i = 1:N
    switch round(10*abs(Epo0(i)-round(Epo0(i))))
    case 0
        PocetPr=PocetPr+1;
        E11(PocetPr)=Epo0(i);    %primary minima times
        Occ1(PocetPr)=O(i);
        B1(PocetPr)=Weight(i);
    case 5                  %secondary minima times
        PocetS=PocetS+1;
        E21(PocetS)=Epo0(i);
        Occ2(PocetS)=O(i);   
        B2(PocetS)=Weight(i);
    end
end

for i = 1:PocetPr
    Primary0(i) = (Primary(JD00,E11(i),P,excen1,dodt*pi/180,omega1*pi/180)-JD00-P*E11(i))-Occ1(i);
    Primary0(i) = B1(i)*(Primary0(i) * Primary0(i));
end

Pa=P/(1-dodt*pi/(2*pi*180));
for i = 1:PocetS
    Sekundary(i) = (Secondary(JD00,E21(i),P,excen1,dodt*pi/180,omega1*pi/180)-JD00-P*E21(i)-Pa/2)-Occ2(i);
    Sekundary(i) = B2(i)*(Sekundary(i) * Sekundary(i));
end

Celkem = sum(Primary0) + sum(Sekundary);

Result = Celkem;
